<template>
  <BasicModal
    v-bind="$attrs"
    @register="register"
    title="开票登记"
    @visible-change="handleVisibleChange"
    @cancel="resetFields"
    @ok="handleSubmit"
  >
    <div class="pt-2px pr-3px">
      <BasicForm @register="registerForm">
        <template #text="{ model, field }">
          {{ model[field]  }}{{fileFlow.type}}
        </template>
      </BasicForm>
    </div>
  </BasicModal>
</template>
<script lang="ts">
  import { defineComponent, nextTick, onMounted, reactive, computed } from 'vue';
  import { BasicModal, useModalInner } from '/@/components/Modal';
  import { BasicForm, FormSchema, useForm } from '/@/components/Form/index';
  import { useMessage } from '/@/hooks/web/useMessage';
  import { InvoiceRegister } from '/@/api/order';
  import { useI18n } from '/@/hooks/web/useI18n';
  import { uploadApi } from '/@/api/product/index';
  import { ResultEnum } from '/@/enums/httpEnum';
  import { DetailsApi, IncrementDelayApi, AddUserIncrementApi, AddDownNumApi } from '/@/api/account';
  import dayjs from 'dayjs';
  import { otherInfoStore } from '/@/store/modules/other'

  const { t } = useI18n();
  export default defineComponent({
    components: { BasicModal, BasicForm },
    props: {
      userData: { type: Object },
    },
    emits: ['update', 'register'],
    setup(props, { emit }) {
      const otherInfo = otherInfoStore();
      const overviewInfo = computed(() => otherInfo.getOverviewInfo);
      // const overviewInfo = getOverviewInfo() || {}
      const fileFlow = reactive({
        file:null,
        id:'',
        type:'down',//down-下载，equity-权益
      })
      const { createMessage } = useMessage();
      const schemas: FormSchema[] = [
          {
            field: 'id',
            component: 'Input',
            show:false,
            label: '发票编号',
            required: true,
          },
          {
            field: 'counts',
            component: 'InputNumber',
            label: '新增权益数',
            componentProps: {
              min:1,
            },
            colProps: {
              span: 22,
            },
          },
          {
            field: 'incrementEndTime',
            component: 'DatePicker',
            label: '到期日期',
            required: true,
            componentProps: {
              valueFormat: 'YYYY-MM-DD',
              format: 'YYYY-MM-DD',
              disabledDate: (current) => {
                return current && current < dayjs().endOf('day');
              },
            },
          },
          // {
          // field: 'year',
          // component: 'Select',
          // label: '到期日期',
          // colProps: {
          //   span: 22,
          // },
          // required: true,
          // componentProps: {
          //   options:[{
          //     label: '1年',
          //     value: 1,
          //     key: '1',
          //   },{
          //     label: '2年',
          //     value: 2,
          //     key: '2',
          //   },{
          //     label: '3年',
          //     value: 3,
          //     key: '3',
          //   },{
          //     label: '4年',
          //     value: 4,
          //     key: '4',
          //   }]
          // },
          // },
          {
            field: 'count',
            component: 'InputNumber',
            label: '新增次数',
            required: true,
            componentProps: {
              min:1,
            },
            colProps: {
              span: 22,
            },
          }
      ];

      const [registerForm, { validate, resetFields, setFieldsValue, updateSchema }] = useForm({
        labelWidth: 120,
        schemas:schemas,
        showActionButtonGroup: false,
        actionColOptions: {
          span: 24,
        },
      });
      onMounted(() => {});
      let addListFunc = () => {};
      const [register, { closeModal }] = useModalInner((data) => {
        data && onDataReceive(data);
      });
      function onDataReceive(data) {
        console.log('onDataReceive',data)
        resetFields();
        fileFlow.type = data.type
        fileFlow.id = data.id
        setFieldsValue(data);
        updateSchema([
          {field: 'count',ifShow:fileFlow.type == 'down',},
          {field: 'incrementEndTime',ifShow:fileFlow.type == 'equity',},
          {field: 'counts',ifShow:fileFlow.type == 'equity',},
        ])
      }
      const handleSubmit = async () => {
        const submitUrl = fileFlow.type == 'equity'?AddUserIncrementApi:AddDownNumApi
        try {
          const params = await validate();
          console.log('validate',params)
          const apiData = fileFlow.type == 'equity'?{
              userId:params.id,
              incrementEndTime:params.incrementEndTime,
              count:params.counts,
            }:{
              userId:params.id,
              count:params.count,
            // file:params.file[0],
            }
          const res = await submitUrl(apiData);
          if(fileFlow.type == 'equity'){
            overviewInfo.value.incrementCount = overviewInfo.value.incrementCount + apiData.count
          }else{
            overviewInfo.value.surDownNum = overviewInfo.value.surDownNum + apiData.count
          }
          console.log('res', overviewInfo.value);
          otherInfo.setOverviewInfo(overviewInfo.value)
          closeModal();
          resetFields();
          createMessage.success(t('common.optSuccess'));
          emit('update');
        } catch (error) {
          console.log('not passing', error);
        }
      };
      function handleVisibleChange(v) {
        v && props.userData && nextTick(() => onDataReceive(props.userData));
      }
      return {
        register,
        registerForm,
        fileFlow,
        handleVisibleChange,
        handleSubmit,
        addListFunc,
        resetFields,
        t,
      };
    },
  });
</script>
